Wednesday, December 31, 2014

1. Two sum leetcode Java

Two Sum

 Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution.
Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Solution:
Clearly, O(n^2) using brute force: check the sum of each pair of numbers in this array and see if the sum is equal to the target.
My O(n) solution is following:
Using a hashmap to record the visited number with its index, check if (target-current element) exist in the hashmap,if yes then the existing one is the first element, current element is the second element.

 public int[] twoSum(int[] numbers, int target) {  
    if (numbers==null || numbers.length<2) return null;  
    int[] res=new int[2];  
    HashMap<Integer,Integer> map=new HashMap<Integer,Integer>();  
    for(int i=0; i< numbers.length;i++){  
      if(map.containsKey(target-numbers[i])){  
        res[0]=map.get(target-numbers[i]);  
        res[1]=i+1;  
        return res;  
      }  
      map.put(numbers[i],i+1);  
    }  
    return res;  
   }  

No comments:

Post a Comment